osg::Fog Class Reference

`#include <Fog>`

Inheritance diagram for osg::Fog:

## Public Types

enum | Mode { LINEAR = GL_LINEAR , EXP = GL_EXP , EXP2 = GL_EXP2 }
enum | FogCoordinateSource { FOG_COORDINATE = GL_FOG_COORDINATE , FRAGMENT_DEPTH = GL_FRAGMENT_DEPTH }
Public Types inherited from osg::StateAttribute
enum | Values { OFF = 0x0 , ON = 0x1 , OVERRIDE = 0x2 , PROTECTED = 0x4 , INHERIT = 0x8 }

enum

Type {
TEXTURE , POLYGONMODE , POLYGONOFFSET , MATERIAL ,
ALPHAFUNC , ANTIALIAS , COLORTABLE , CULLFACE ,
FOG , FRONTFACE , LIGHT , POINT ,
LINEWIDTH , LINESTIPPLE , POLYGONSTIPPLE , SHADEMODEL ,
TEXENV , TEXENVFILTER , TEXGEN , TEXMAT ,
LIGHTMODEL , BLENDFUNC , BLENDEQUATION , LOGICOP ,
STENCIL , COLORMASK , DEPTH , VIEWPORT ,
SCISSOR , BLENDCOLOR , MULTISAMPLE , CLIPPLANE ,
COLORMATRIX , VERTEXPROGRAM , FRAGMENTPROGRAM , POINTSPRITE ,
PROGRAM , CLAMPCOLOR , HINT , SAMPLEMASKI ,
PRIMITIVERESTARTINDEX , CLIPCONTROL , VALIDATOR , VIEWMATRIXEXTRACTOR ,
OSGNV_PARAMETER_BLOCK , OSGNVEXT_TEXTURE_SHADER , OSGNVEXT_VERTEX_PROGRAM , OSGNVEXT_REGISTER_COMBINERS ,
OSGNVCG_PROGRAM , OSGNVSLANG_PROGRAM , OSGNVPARSE_PROGRAM_PARSER , UNIFORMBUFFERBINDING ,
TRANSFORMFEEDBACKBUFFERBINDING , ATOMICCOUNTERBUFFERBINDING , PATCH_PARAMETER , FRAME_BUFFER_OBJECT ,
VERTEX_ATTRIB_DIVISOR , SHADERSTORAGEBUFFERBINDING , INDIRECTDRAWBUFFERBINDING , VIEWPORTINDEXED ,
DEPTHRANGEINDEXED , SCISSORINDEXED , BINDIMAGETEXTURE , SAMPLER ,
CAPABILITY = 100
}

typedef GLenum | GLMode
typedef unsigned int | GLModeValue
typedef unsigned int | OverrideValue
typedef std::pair< Type, unsigned int > | TypeMemberPair
typedef std::vector< StateSet * > | ParentList
typedef osg::StateAttributeCallback | Callback
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Fog ()
| Fog (const Fog &fog, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_StateAttribute (osg, Fog, FOG)
virtual int | compare (const StateAttribute &sa) const
virtual bool | getModeUsage (StateAttribute::ModeUsage &usage) const
void | setMode (Mode mode)
Mode | getMode () const
void | setDensity (float density)
float | getDensity () const
void | setStart (float start)
float | getStart () const
void | setEnd (float end)
float | getEnd () const
void | setColor (const Vec4 &color)
const Vec4 & | getColor () const
void | setUseRadialFog (bool useRadialFog)
bool | getUseRadialFog () const
void | setFogCoordinateSource (GLint source)
GLint | getFogCoordinateSource () const
virtual void | apply (State &state) const
Public Member Functions inherited from osg::StateAttribute
| StateAttribute ()
| StateAttribute (const StateAttribute &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Texture * | asTexture ()
virtual const Texture * | asTexture () const
virtual Type | getType () const =0
virtual unsigned int | getMember () const
TypeMemberPair | getTypeMemberPair () const
virtual bool | isTextureAttribute () const
bool | operator< (const StateAttribute &rhs) const
bool | operator== (const StateAttribute &rhs) const
bool | operator!= (const StateAttribute &rhs) const
const ParentList & | getParents () const
StateSet * | getParent (unsigned int i)
const StateSet * | getParent (unsigned int i) const
unsigned int | getNumParents () const
void | setShaderComponent (ShaderComponent *sc)
ShaderComponent * | getShaderComponent ()
const ShaderComponent * | getShaderComponent () const
virtual bool | checkValidityOfAssociatedModes (osg::State &) const
void | setUpdateCallback (StateAttributeCallback *uc)
StateAttributeCallback * | getUpdateCallback ()
const StateAttributeCallback * | getUpdateCallback () const
void | setEventCallback (StateAttributeCallback *ec)
StateAttributeCallback * | getEventCallback ()
const StateAttributeCallback * | getEventCallback () const
virtual void | compileGLObjects (State &) const
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (State *=0) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Fog ()
Protected Member Functions inherited from osg::StateAttribute
virtual | ~StateAttribute ()
void | addParent (osg::StateSet *object)
void | removeParent (osg::StateSet *object)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

Mode | _mode
float | _density
float | _start
float | _end
Vec4 | _color
GLint | _fogCoordinateSource
bool | _useRadialFog
Protected Attributes inherited from osg::StateAttribute
ParentList | _parents
ref_ptr< ShaderComponent > | _shaderComponent
ref_ptr< StateAttributeCallback > | _updateCallback
ref_ptr< StateAttributeCallback > | _eventCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Fog - encapsulates OpenGL fog state.

## Member Enumeration Documentation

## FogCoordinateSource

enum osg::Fog::FogCoordinateSource

Enumerator
FOG_COORDINATE |
FRAGMENT_DEPTH |

## Mode

enum osg::Fog::Mode

Enumerator
LINEAR |
EXP |
EXP2 |

## Constructor & Destructor Documentation

## Fog() [1/2]

osg::Fog::Fog | ( |  | ) |

Referenced by compare(), Fog(), and META_StateAttribute().

## Fog() [2/2]

osg::Fog::Fog | ( | const Fog & | fog,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

inline

Copy constructor using CopyOp to manage deep vs shallow copy.

References _color, _density, _end, _fogCoordinateSource, _mode, _start, _useRadialFog, Fog(), osg::CopyOp::SHALLOW_COPY, and osg::StateAttribute::StateAttribute().

## ~Fog()

virtual osg::Fog::~Fog | ( |  | ) |

protected virtual

## Member Function Documentation

## apply()

virtual void osg::Fog::apply | ( | State & |  | ) | const

virtual

apply the OpenGL state attributes. The render info for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state.

Reimplemented from osg::StateAttribute.

## compare()

virtual int osg::Fog::compare | ( | const StateAttribute & | sa | ) | const

inline virtual

return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.

Implements osg::StateAttribute.

References _color, _density, _end, _fogCoordinateSource, _mode, _start, _useRadialFog, COMPARE_StateAttribute_Parameter, COMPARE_StateAttribute_Types, Fog(), and osg::StateAttribute::StateAttribute().

## getColor()

const Vec4 & osg::Fog::getColor | ( |  | ) | const

inline

References _color.

## getDensity()

float osg::Fog::getDensity | ( |  | ) | const

inline

References _density.

## getEnd()

float osg::Fog::getEnd | ( |  | ) | const

inline

References _end.

## getFogCoordinateSource()

GLint osg::Fog::getFogCoordinateSource | ( |  | ) | const

inline

References _fogCoordinateSource.

## getMode()

Mode osg::Fog::getMode | ( |  | ) | const

inline

References _mode.

## getModeUsage()

virtual bool osg::Fog::getModeUsage | ( | StateAttribute::ModeUsage & |  | ) | const

inline virtual

Return the modes associated with this StateAttribute.

Reimplemented from osg::StateAttribute.

References GL_FOG, and osg::StateAttribute::ModeUsage::usesMode().

## getStart()

float osg::Fog::getStart | ( |  | ) | const

inline

References _start.

## getUseRadialFog()

bool osg::Fog::getUseRadialFog | ( |  | ) | const

inline

References _useRadialFog.

## META_StateAttribute()

osg::Fog::META_StateAttribute | ( | osg | ,
|  | Fog | ,
|  | FOG | )

References osg::StateAttribute::FOG, and Fog().

## setColor()

void osg::Fog::setColor | ( | const Vec4 & | color | ) |

inline

References _color.

## setDensity()

void osg::Fog::setDensity | ( | float | density | ) |

inline

References _density.

## setEnd()

void osg::Fog::setEnd | ( | float | end | ) |

inline

References _end.

## setFogCoordinateSource()

void osg::Fog::setFogCoordinateSource | ( | GLint | source | ) |

inline

References _fogCoordinateSource.

## setMode()

void osg::Fog::setMode | ( | Mode | mode | ) |

inline

References _mode.

## setStart()

void osg::Fog::setStart | ( | float | start | ) |

inline

References _start.

## setUseRadialFog()

void osg::Fog::setUseRadialFog | ( | bool | useRadialFog | ) |

inline

References _useRadialFog.

## Member Data Documentation

## _color

Vec4 osg::Fog::_color

protected

Referenced by compare(), Fog(), getColor(), and setColor().

## _density

float osg::Fog::_density

protected

Referenced by compare(), Fog(), getDensity(), and setDensity().

## _end

float osg::Fog::_end

protected

Referenced by compare(), Fog(), getEnd(), and setEnd().

## _fogCoordinateSource

GLint osg::Fog::_fogCoordinateSource

protected

Referenced by compare(), Fog(), getFogCoordinateSource(), and setFogCoordinateSource().

## _mode

Mode osg::Fog::_mode

protected

Referenced by compare(), Fog(), getMode(), and setMode().

## _start

float osg::Fog::_start

protected

Referenced by compare(), Fog(), getStart(), and setStart().

## _useRadialFog

bool osg::Fog::_useRadialFog

protected

Referenced by compare(), Fog(), getUseRadialFog(), and setUseRadialFog().

The documentation for this class was generated from the following file:

- Fog